using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using System.Threading;




namespace EG12000
{
    public partial class Form1 : Form
    {
        private delegate void nextLimbDeleg(byte[] limb);
        private delegate void nextChestDeleg(byte[] chest);
        private delegate void nextValueDeleg(byte[] value);
        private delegate void nextStatusDeleg(byte[] status);
        private delegate void nextStatusChestDeleg(byte[] statusChest);
        private delegate void nextIdentifyDeleg(String message);
        private delegate void nextUpdateDeleg();

        
       
    
        EKG ekg = null;
        bool tone = false;
        bool save = false;
        byte[] buffer ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        byte buf = 0;
        
        


        public Form1()
        {
            InitializeComponent();
            ekg = new EKG(this);
            list_comport();
           
            ekg.Rand = 30;

            
            
        }

        // search all Comports 
        private void list_comport()
        {
            {
                // Get a list of serial port names. 
                string[] ports = SerialPort.GetPortNames();

                portToolStripMenuItem.DropDownItems.Clear();
                portToolStripMenuItem.DropDownItems.Add("Update...", null, new EventHandler(updateToolStripMenuItem_Click));
                // Display each port name to the console. 
                foreach (string port in ports)
                {

                    portToolStripMenuItem.DropDownItems.Add(port, null, new EventHandler(port_Click));
                }
            }
        }

        private void updateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            list_comport();
            foreach (ToolStripMenuItem item in portToolStripMenuItem.DropDownItems)
            {
                if (item.Text == toolStripStatusLabel_Port.Text)
                {
                    item.Checked = true;
                }
            }
        }
        
        // open Comport
        private void port_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.DiscardInBuffer();
                serialPort1.Close();

            if (((ToolStripMenuItem)sender).Checked == false)
            {
                foreach (ToolStripMenuItem item in portToolStripMenuItem.DropDownItems)
                {
                    item.Checked = false;
                }
                string Port = sender.ToString();
               // ((ToolStripMenuItem)sender).Checked = true;
                serialPort1.PortName = Port;
                try
                {
                    serialPort1.Open();

                }
                catch
                {
                    MessageBox.Show("Serial port " + serialPort1.PortName +
                            " cannot be opened!", "RS232 tester",
                            MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                if (serialPort1.IsOpen)
                {
                    ((ToolStripMenuItem)sender).Checked = true;
                    toolStripStatusLabel_Port.Text = Port;
                    timer2.Start();
                }
            }
            else
            {
                ((ToolStripMenuItem)sender).Checked = false;
                toolStripStatusLabel_Port.Text = "No Port...";
            }


            if (serialPort1.IsOpen)
            {
                serialPort1.WriteLine("I");


                radioButton_Amp1.PerformClick();
                radioButton_100.PerformClick();
                radioButton_normal.PerformClick();
                radioButton_emgOff.PerformClick();
                radioButton_Monitor.PerformClick();
                radioButton_paceOn.PerformClick();
                //radioButton_50.PerformClick();
            }

        }
        
        // parse serial Data
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            while (serialPort1.BytesToRead > 6)
            {

                buf = Convert.ToByte(serialPort1.ReadByte());

                if (buf > 0xf7)
                {
                    if (buf == 0xfd)
                    {
                        string temp = "";//Status = buf;

                        temp = serialPort1.ReadTo("\0");

                        this.BeginInvoke(new nextIdentifyDeleg(ekg.nextIdentify), new object[] { temp });
                    }
                    else
                    {
                        byte[] tempbuffer ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                        buffer[0] = buf;
                        if (serialPort1.IsOpen)
                        {
                            buffer[1] = Convert.ToByte(serialPort1.ReadByte());
                        }

                        if (buffer[0] == 0xf8)
                        {
                            //SPO = buf;
                            int temp = ((buffer[1]) >> 4) + 2;

                            if (temp < 11)
                            {
                                for (int i = 2; i < temp; i++)
                                {
                                    if (serialPort1.IsOpen)
                                    {
                                        buffer[i] = Convert.ToByte(serialPort1.ReadByte());
                                    }
                                }
                                // byte[] tempbuffer ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ,0,0};
                                Buffer.BlockCopy(buffer, 0, tempbuffer, 0, temp);
                                this.BeginInvoke(new nextLimbDeleg(ekg.nextLimb), new object[] { tempbuffer });
                            }
                        }
                        else if (buffer[0] == 0xfe)
                        {

                            int temp = ((buffer[1]) >> 4) + 2;
                            if (temp < 8)
                            {
                                for (int i = 2; i < temp; i++)
                                {
                                    if (serialPort1.IsOpen)
                                    {
                                        buffer[i] = Convert.ToByte(serialPort1.ReadByte());
                                    }
                                }
                                Buffer.BlockCopy(buffer, 0, tempbuffer, 0, temp);
                                this.BeginInvoke(new nextChestDeleg(ekg.nextChest), new object[] { tempbuffer });
                            }
                        }

                        else if ((buffer[0] == 0xf9) || (buffer[0] == 0xfa))
                        {
                            if (serialPort1.IsOpen)
                            {
                                buffer[2] = Convert.ToByte(serialPort1.ReadByte());
                            }

                            Buffer.BlockCopy(buffer, 0, tempbuffer, 0, 3);
                            this.BeginInvoke(new nextValueDeleg(ekg.nextValue), new object[] { tempbuffer });
                        }
                        else if (buffer[0] == 0xfc)
                        {

                            for (int i = 2; i < 6; i++)
                            {
                                if (serialPort1.IsOpen)
                                {
                                    buffer[i] = Convert.ToByte(serialPort1.ReadByte());
                                }
                            }

                            Buffer.BlockCopy(buffer, 0, tempbuffer, 0, 6);
                            this.BeginInvoke(new nextStatusDeleg(ekg.nextStatus), new object[] { tempbuffer });
                        }
                        else if (buffer[0] == 0xff)
                        {
                            //Status = buf;
                            for (int i = 2; i < 4; i++)
                            {
                                if (serialPort1.IsOpen)
                                {
                                    buffer[i] = Convert.ToByte(serialPort1.ReadByte());
                                }
                            }

                            Buffer.BlockCopy(buffer, 0, tempbuffer, 0, 4);
                            this.BeginInvoke(new nextStatusChestDeleg(ekg.nextStatusChest), new object[] { tempbuffer });
                        }
                    }
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
            Application.Exit();
        }

        // Check all electrodes
        private void button_electrodes_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.WriteLine("q0");
        }

        // simulate / Normal-mode
        private void Mode_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Normal")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("M0");
            }
            if (((RadioButton)sender).Text == "Simulate")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("M1");
            }
        }

        private void Modus_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Adult")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("N0");
            }
            if (((RadioButton)sender).Text == "Neonates")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("N1");
            }
        }

        // Check buttons for EMG-Filter
        private void EMG_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "On")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("E1");
            }
            if (((RadioButton)sender).Text == "Off")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("E0");
            }
        }

        //en- / disable Pacemakerdetection
        private void Pace_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "On")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P1");
            }
            if (((RadioButton)sender).Text == "Off")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P0");
            }
            if (((RadioButton)sender).Text == "P2")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P2");
            }
            if (((RadioButton)sender).Text == "P3")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P3");
            }
        }

        // en- / disable Pacemakerdetection
        private void Bandwidth_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Diag.")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("F0");
            }
            else if (((RadioButton)sender).Text == "Monitor")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("F1");
            }

            else if (((RadioButton)sender).Text == "FS")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("FS");
            }
        }

        // Amplitude if the signal
        private void Amplitute_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Amp 1")
            {
                ekg.Max_Wert = 8;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A0");
             
                }
            }
            if (((RadioButton)sender).Text == "Amp 2")
            {
                ekg.Max_Wert = 4;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A1");
                }
            }
            if (((RadioButton)sender).Text == "Amp 3")
            {
                ekg.Max_Wert = 2;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A2");
                }
            }
            if (((RadioButton)sender).Text == "Amp 4")
            {
                ekg.Max_Wert = 1;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A3");
                }
            }
            //toolStripStatusLabel_Amplitude.Text = ((RadioButton)sender).Text;
        }

        // 50Hz / 60Hz filter
        private void Filter_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "50 Hz")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("51");
            }
            if (((RadioButton)sender).Text == "60 Hz")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("52");
            }
            if (((RadioButton)sender).Text == "Off")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("50");
            }
        }

        // Speed of the Graph
        private void Speed_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "50/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S0");
                
            }
            else if (((RadioButton)sender).Text == "100/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S1");
            }
            else if (((RadioButton)sender).Text == "150/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S2");
            }

            else if (((RadioButton)sender).Text == "300/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S7");
            }
               //toolStripStatusLabel_Speed.Text =((RadioButton)sender).Text;
        }

        // Check Channels
        private void Channel1_Checked(object sender, EventArgs e)
        {
            int cnt_channel_temp = 0;
            byte[] temp ={ 0x43, 0 };
            byte[] temp2 ={ 0x44, 0 };
            
            for (int i = 0; i < splitContainer1.Panel1.Controls.Count; i++)
            {
                foreach (Control Ctrl in splitContainer1.Panel1.Controls)
                {
                    if ((((CheckBox)Ctrl).Checked == true) & (((CheckBox)Ctrl).Enabled == true))
                    {
                        if (((CheckBox)Ctrl).Text != "All")
                        {

                            if (((CheckBox)Ctrl).TabIndex == i)
                            {
                                temp[1] |= (byte)(1 << i);
                                
                                cnt_channel_temp++;
                            }
                        }
                    }
                }
            }
            ekg.Channel_limb_Count = cnt_channel_temp;
            for (int i = 0; i < splitContainer1.Panel2.Controls.Count; i++)
            {
                foreach (Control Ctrl in splitContainer1.Panel2.Controls)
                {
                    if ((((CheckBox)Ctrl).Checked == true) & (((CheckBox)Ctrl).Enabled == true))
                    {
                        if (((CheckBox)Ctrl).Text != "All")
                        {

                            if (((CheckBox)Ctrl).TabIndex == i)
                            {
                                temp2[1] |= (byte)(1 << i);
                                
                                cnt_channel_temp++;
                            }
                        }
                    }
                }
            }

            if (serialPort1.IsOpen)
            {

                serialPort1.Write(temp, 0, 2);
                if (ekg.flag_eg1200 == true)
                    serialPort1.Write(temp2, 0, 2);
            }
            ekg.Channel_Count = cnt_channel_temp;

            ekg.Index = ekg.Rand+2;
           
            ekg.Packetsread = 0;
            ekg.display_diag();




        }

        private void Form1_Leave(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            if (ekg.outfileCtr > 0)
                ekg.outfile.Close();

        }

        // update time in the statusbar
        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel_time.Text = DateTime.Now.ToLongTimeString();
        }

        string File= null;

        //Dialogbox for Savefile
        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                SaveFileDialog dialog = new SaveFileDialog();
                dialog.Filter = "Log files (*.log)|*.log|txt files (*.txt)|*.txt|All files (*.*)|*.*";
                dialog.Title = "Select a file";
                //dialog.ShowDialog();


                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    File = dialog.FileName;
                    //ekg.outfile = new StreamWriter(dialog.FileName);
                    //ekg.outfileCtr = 1;

                    toolStripStatusLabel1.Text = dialog.FileName;
                }

            }
            else
            {
                MessageBox.Show("Please select Com-Port first", "Open Dialog",
                          MessageBoxButtons.OK, MessageBoxIcon.Warning);


            }
        }
        
        // en- / disable pulseton
        private void onToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (onToolStripMenuItem.Checked == true)
                onToolStripMenuItem.Checked = false;
            else if (onToolStripMenuItem.Checked == false)
                onToolStripMenuItem.Checked = true;
            tone = onToolStripMenuItem.Checked;

        }

        // en- / disable Datasaving 
        private void SaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (((ToolStripMenuItem)sender).Text == "okay")
            {
                if (ekg.outfile == null)
                {
                    if (File != null)
                    {
                        
                        //ekg.outfileCtr = 1;
                        try
                        {
                            ekg.outfile = new StreamWriter(File);
                        }
                        catch
                        {
                            MessageBox.Show("Datei " + File +
                                    " cannot be opened!", "Datei fehler",
                                    MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        }
                    }
                }
                
                if (ekg.outfile != null)
                {
                    okayToolStripMenuItem.Checked = true;
                    ekg.outfileCtr = 1;

                    if (ekg.flag_eg1200 == true)
                    {
                        ekg.outfile.WriteLine("EG12000");
                        ekg.outfile.WriteLine("\"I\"\t\"II\"\t\"III\"\t\"aVR\"\t\"aVL\"\t\"aVF\"\t\"C1\"\t\"Resp\"\t\"C2\"\t\"C3\"\t\"C4\"\t\"C5\"\t\"C6\"");
                    }
                    else
                    {
                        ekg.outfile.WriteLine("EG05000");
                        ekg.outfile.WriteLine("\"I\"\t\"II\"\t\"III\"\t\"aVR\"\t\"aVL\"\t\"aVF\"\t\"C1\"\t\"Resp\"");
                    }
                    save = true;
                }
            }
            else if (((ToolStripMenuItem)sender).Text == "abort")
            {
                okayToolStripMenuItem.Checked = false;
                save = false;
                ekg.outfileCtr = 0; 
                ekg.outfile.Close();
                ekg.outfile = null;
            }

        }

        private void tableLayoutPanel1_Resize(object sender, EventArgs e)
        {
            if (ekg != null)
            {
                //grenzen.Height = pictureBox_Graph.Height;
                //grenzen.Width = pictureBox_Graph.Width;
                ekg.display_diag();
                
            }
        }

        // Checkbox all Channels
        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            foreach (Control Ctrl in splitContainer1.Panel1.Controls)
            {
                ((CheckBox)Ctrl).Checked = checkBox9.Checked;
            }
            foreach (Control Ctrl in splitContainer1.Panel2.Controls)
            {
                if (((CheckBox)Ctrl).Enabled == true)
                    ((CheckBox)Ctrl).Checked = checkBox9.Checked;
            }
        }

        // Timer update Graph
        private void timer2_Tick(object sender, EventArgs e)
        {
            this.BeginInvoke(new nextUpdateDeleg(ekg.update ), new object[] { });

        }

        
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 frm = new AboutBox1();
            frm.Show();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            exitToolStripMenuItem.PerformClick();
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (((TabControl)sender).SelectedIndex == 1)
            {
                groupBox_Channel.Select();
                groupBox1.Select();
            }
        }

        class EKG
        {
            private static int Flag_LL = 0x01;      // 00000001
            private static int Flag_RL = 0x02;      // 00000010
            private static int Flag_LA = 0x04;      // 00000100
            private static int Flag_RA = 0x08;      // 00001000
            private static int Flag_Chest = 0x10;   // 00010000
            private static int Flag_C2 = 0x0100;    // 00000001
            private static int Flag_C3 = 0x0200;    // 00000010
            private static int Flag_C4 = 0x0400;    // 00000100
            private static int Flag_C5 = 0x0800;    // 00001000
            private static int Flag_C6 = 0x1000;    // 00010000

            string[] Signal = { "I", "II", "III", "aVR", "aVL", "aVF", "C1", 
                                "Resp", "C2", "C3", "C4", "C5", "C6" };

            string[] status ={ "Normal", "Normal + Pacemaker detected", "not used", "not used", "Initializing",
                               "Searching for electrodes", "not used", "not used", "Simulated Output", "not used", 
                               "Selftest Error", "not used", "not used", "not used", "not used", "not used" };

           
            Form1 form1;

            StreamWriter Outfile;


            // Channel class for all parameter
            public class channel
            {
                public string CH_name;
                public int _hoehe ;
                public int _base ;
                public Color Color;
                public bool xoffset;
                public int old_wave;

                public channel(string n, int h, int b, Color col, bool off)
                {
                    CH_name = n;
                    _hoehe  = h;
                    _base = b;
                    Color = col;
                    xoffset = off;
                    old_wave = 0;
                }
            }
           
            int Outfilectr = -1;
            int cnt_Channel = 0;
            int cnt_Channel1 = 0;


            channel[] Channel = new channel[]
            {
                new channel("I",0, 0, Color.Blue, false),
                new channel("II",0, 0, Color.Brown, false),
                new channel("III",0, 0, Color.Green, false),
                new channel("aVR",0, 0, Color.Black , false),
                new channel("aVL",0, 0, Color.Blue, false),
                new channel("aVF",0, 0, Color.Indigo, false),
                new channel("C1",0, 0, Color.Green, false),
                new channel("Resp",0, 0, Color.BlueViolet, false),
                new channel("C2",0, 0, Color.MediumAquamarine, false),
                new channel("C3",0, 0, Color.IndianRed, false),
                new channel("C4",0, 0, Color.MediumPurple, false),
                new channel("C5",0, 0, Color.Orange, false),
                new channel("C6",0, 0, Color.PaleVioletRed, false)
            };
          
            
            int column = 1;         // Column of the graph
            byte rand;
            int index;
            byte gr_rand = 20;
            int max_Wert;

          
            int[] Datensatz;        // Array of last Wavevalues
            int packetsread = 0;

            bool Flag_eg1200 = false;

            public EKG(Form1 frm)
            {
                form1 = frm;
                
                Datensatz = new int[13];
                index = rand + 2;
                
                 
                form1.pictureBox_Graph.Image = new Bitmap(form1.pictureBox_Graph.Width, form1.pictureBox_Graph.Height);

            }

            public StreamWriter outfile
            {
                get
                {
                    return Outfile;
                }

                set
                {
                    Outfile = value;
                }
            }

            public bool flag_eg1200
            {
                get
                {
                    return Flag_eg1200;
                }
                set
                {
                    Flag_eg1200 = value;
                }

            }

            public int Channel_Count
            {
                get
                {
                    
                    return cnt_Channel;
                }
                set
                {
                    if (value > 7)
                        column = 2;
                    else column = 1;
                    cnt_Channel = value;
                }
            }

            public int outfileCtr
            {
                get
                {
                    return Outfilectr;
                }
                set
                {
                    Outfilectr = value;
                }
            }

            public int Channel_limb_Count
            {
                get
                {
                    return cnt_Channel1;
                }
                set
                {
                    cnt_Channel1 = value;
                }
            }

            public int Index
            {
                get
                {
                    return index;
                }
                set
                {
                    index = value;
                }
            }

            public int Packetsread
            {
                get
                {
                    return packetsread;
                }
                set
                {
                    packetsread  = value;
                }
            }
            
            public int Max_Wert
            {
                get
                {
                    return max_Wert ;
                }
                set
                {
                    max_Wert = value;
                }
            }

            public byte Rand
            {
                get
                {
                    return rand;
                }
                set
                {
                    rand = value;
                }
            }
 
            //parsing identify message
            public void nextIdentify(string message)
            {
                form1.label_Identify.Text = message;
                if (message.Contains("EG12000"))
                {
                    Flag_eg1200 = true;
                    //form1.WaveValue = new int[13];
                }
                else
                {
                    Flag_eg1200 = false;
                    //form1.WaveValue = new int[8];
                }

                if (Flag_eg1200 == true)
                {
                    form1.checkBox_C2.Enabled = true;
                    form1.checkBox_C3.Enabled = true;
                    form1.checkBox_C4.Enabled = true;
                    form1.checkBox_C5.Enabled = true;
                    form1.checkBox_C6.Enabled = true;
                    form1.label_C2.Enabled = true;
                    form1.label_C3.Enabled = true;
                    form1.label_C4.Enabled = true;
                    form1.label_C5.Enabled = true;
                    form1.label_C6.Enabled = true;
                }
            }

            //  81   82   83   84   85   86   87   88   89   90   91   92   93   94   95   96    97    98    99    100
            int[] pt = { 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1046, 1109, 1175, 1244, 1328 };

            //Funktion for Sound of Piep
            private void Piep(double Frequenz, int time)
            {
                const int MinFreq = 0x25;
                const int MaxFreq = 0x7FFF;

                if (Frequenz < MinFreq)
                    Frequenz = MinFreq;
                else if (Frequenz > MaxFreq)
                    Frequenz = MaxFreq;
                Console.Beep((int)(Frequenz), time);
            }

            //parsing Value for pulse and respiration
            public void nextValue(byte[] buffer)
            {
                int lng = 3;
                int check = (buffer[1] & 0x7f);
                int temp = 0;
                for (int i = 2; i < lng; i++)
                {
                    temp += buffer[i];
                }
                temp += buffer[0];
                temp = temp % 128;
                if (temp == check)
                {
                    if ((buffer[0] & 0x03) == 1)
                    {
                        form1.label_Pulse.Text = buffer[2].ToString();
                        if ((form1.tone == true)&& (buffer[2]!= 0))     // Have to beep ?
                        {

                            int frq = 0;


                            Piep(pt[frq], 50);
                        }
                    }
                    else if ((buffer[0] & 0x03) == 2)
                    {
                        form1.label_Resp.Text = buffer[2].ToString();
                    }
                }
            }

            bool Status_ok = false;

            // parsing statusmessage and electrodes I - C1
            public void nextStatus(byte[] buffer)
            {

                int lng = 6;
                int check = (buffer[1] & 0x7f);
                int temp = 0;
                
                for (int i = 2; i < lng; i++)
                {
                    temp += buffer[i];
                }
                temp += buffer[0];
                temp = temp % 128;
                if (temp == check)
                {
                    electrode_check((buffer[2] & 0x1F) + 0x80);
                    form1.label_Status.Text = status[(buffer[5] & 0x0f)];
                    if ((buffer[5] & 0x40) == 0x40)
                    {
                        form1.toolStripStatusLabel_Modus.Text = "Neonates";
                        form1.radioButton_neo.Checked=true;
                    }
                    else
                    {
                        form1.toolStripStatusLabel_Modus.Text = "Adult";
                        form1.radioButton_adult.Checked = true;
                    }
                    if ((buffer[2] & 0x20) == 0x20)
                    {
                        form1.checkBox_50Hz_inter.Checked = true;
                    }
                    else
                    {
                        form1.checkBox_50Hz_inter.Checked = false;
                        
                    }
                    switch ((buffer[4] & 0x03))
                    {
                        case 0:
                            {
                                form1.radioButton_50.Checked = true;
                                form1.toolStripStatusLabel_Speed.Text = "50/sec";
                                break;
                            }
                        case 1:
                            {
                                form1.radioButton_100.Checked = true;
                                form1.toolStripStatusLabel_Speed.Text = "100/sec";
                                break;
                            }
                        case 2:
                            {
                                form1.radioButton_150.Checked = true;
                                form1.toolStripStatusLabel_Speed.Text = "150/sec";
                                break;
                            }
                        case 3:
                            {
                                form1.radioButton_300.Checked = true;
                                form1.toolStripStatusLabel_Speed.Text = "300/sec";
                                break;
                            }

                    }
                    switch (((buffer[4] & 0x0c)>>2))
                    {
                        case 0:
                            {
                                form1.radioButton_Amp1.Checked = true;
                                form1.toolStripStatusLabel_Amplitude.Text = "Amp 1";
                                break;
                            }
                        case 1:
                            {
                                form1.radioButton_Amp2.Checked = true;
                                form1.toolStripStatusLabel_Amplitude.Text = "Amp 2";
                                break;
                            }
                        case 2:
                            {
                                form1.radioButton_Amp3.Checked = true;
                                form1.toolStripStatusLabel_Amplitude.Text = "Amp 3";
                                break;
                            }
                        case 3:
                            {
                                form1.radioButton_Amp4.Checked = true;
                                form1.toolStripStatusLabel_Amplitude.Text = "Amp 4";
                                break;
                            }

                    }
                   
                   
                    Status_ok = true;
                }
            }

            // parsing for Status of Electrodes C2-C6 (only EG12000)
            public void nextStatusChest(byte[] buffer)
            {
                int lng = 4;
                int check = (buffer[1] & 0x7f);
                int temp = 0;
                for (int i = 2; i < lng; i++)
                {
                    temp += buffer[i];
                }
                temp += buffer[0];
                temp = temp % 128;
                if (temp == check)
                {
                    electrode_check(((buffer[2] & 0x1F) << 8) + 0x8000);
                }

            }

            enum cha { chi, chii, chiii, chvr, chvl, chvf, chc1, chresp, chc2, chc3, chc4, chc5, chc6 };

            //parsing Wavevalue message I - C1
            public void nextLimb(byte[] buffer)
            {
               
                int lng = (buffer[1] >> 4) + 2;
                int check = (buffer[1] & 0x0f);
                int temp = 0;
                for (int i = 2; i < lng; i++)
                {
                    temp += buffer[i];
                }
                temp += buffer[0];
                temp = temp % 16;

                //if (temp == check)
                {
                    for (int i = 2; i < lng; i++)
                    {
                        Datensatz[i - 2] = buffer[i];
                    }
                    
                    Display();
                    if (index % ((form1.pictureBox_Graph.Image.Width / column -35) /10) == 0)
                    {
                        Graphics g = Graphics.FromImage(form1.pictureBox_Graph.Image);
                        //dumint = rand + ((int)(Math.Round((double)((tempxrand - rand) * (j / 10.0)))));
                        g.DrawString(DateTime.Now.ToLongTimeString(), new Font(FontFamily.GenericSerif, 8, FontStyle.Bold), new SolidBrush(Color.Black), new Point( (index ), form1.pictureBox_Graph.Height - 20));
                        //form1.pictureBox_Graph.Refresh();
                        //g.DrawLine(blackPen, new Point(dumint, ch._base - ch._hoehe + gr_rand), new Point(dumint, ch._base));
                    }
                    if (form1.pictureBox_Graph.Image != null)
                    {
                        if (index < (form1.pictureBox_Graph.Image.Width / column - 10))
                        {
                            index = index + 1;
                        }
                        else
                        {
                            index = rand + 2;
                            display_diag_exit = false;
                            display_diag();
                        }
                    }
                     
                }
            }
            
            //parsing Wavevalue message C2- C6 (only EG12000)
            public void nextChest(byte[] buffer)
            {
                int lng = (buffer[1] >> 4) + 2;
                int check = (buffer[1] & 0x0f);
                int temp = 0;
                for (int i = 2; i < lng; i++)
                {
                    temp += buffer[i];
                }
                temp += buffer[0];
                temp = temp % 16;
                
                if (temp == check)
                {
                    for (int i = 2; i < lng; i++)
                    {
                        Datensatz[i - 2 + Channel_limb_Count] = buffer[i];

                    }
                    
                }
            }

            public void electrode_check(int electrode)
            {
                if ((electrode & 0x00ff) != 0)
                {
                    if ((electrode & Flag_LL) == Flag_LL)
                    {
                        form1.label_LL.BackColor = System.Drawing.Color.LawnGreen ;
                    }
                    else form1.label_LL.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_LA) == Flag_LA)
                    {
                        form1.label_LA.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_LA.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_RA) == Flag_RA)
                    {
                        form1.label_RA.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_RA.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_RL) == Flag_RL)
                    {
                        form1.label_RL.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_RL.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_Chest) == Flag_Chest)
                    {
                        form1.label_Chest.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_Chest.BackColor = System.Drawing.Color.Red;

                }
                else if ((electrode & 0xff00) != 0)
                {
                    if ((electrode & Flag_C2) == Flag_C2)
                    {
                        form1.label_C2.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_C2.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_C3) == Flag_C3)
                    {
                        form1.label_C3.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_C3.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_C4) == Flag_C4)
                    {
                        form1.label_C4.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_C4.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_C5) == Flag_C5)
                    {
                        form1.label_C5.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_C5.BackColor = System.Drawing.Color.Red;

                    if ((electrode & Flag_C6) == Flag_C6)
                    {
                        form1.label_C6.BackColor = System.Drawing.Color.LawnGreen;
                    }
                    else form1.label_C6.BackColor = System.Drawing.Color.Red;
                }
            }

            //Bitmap bmp;

            // draw waveform to graph
            private int display_wave(channel ch, int i)
            {
               
                int dumint;
                double factor = (ch._hoehe - gr_rand) / 256.0;

                Graphics g = Graphics.FromImage( form1.pictureBox_Graph.Image);
                Pen drawPen = new Pen(Color.Black, 1);
                drawPen.DashStyle = DashStyle.Solid;
                
                drawPen.Color = ch.Color;
                dumint = ch._base - (int)Math.Round((double)(Datensatz[i++] * factor));
                if ((packetsread > 3) && (display_diag_exit == true)) //(* 1. Datensatz nicht anzeigen	*)
                {
                    if (ch.xoffset == true)
                    {
                        g.DrawLine(drawPen, new Point(index - 1 + form1.pictureBox_Graph.Width / 2, ch.old_wave ), new Point(index + form1.pictureBox_Graph.Width / 2, dumint));
                    }
                    else
                    {
                        g.DrawLine(drawPen, new Point(index - 1, ch.old_wave), new Point(index, dumint));
                    }
                }
                ch.old_wave = dumint;
                 
                g.Dispose();
                drawPen.Dispose();

                return i; 
            }

            // Draw Graphs and save Value
            private void Display()
            {
               
                //bmp = (Bitmap)form1.pictureBox_Graph.Image;

                if ((form1.pictureBox_Graph.Image != null))
                {
                    int i = 0;
                    

                    packetsread += 1;
                    if (packetsread > 5)
                    {
                        packetsread = 5;
                    }
                    foreach (channel Member in Channel)
                    {
                        if (Member._hoehe > 0)
                        {
                            i = display_wave(Member, i);
                        }

                    }
                    if (form1.save == true)
                    {
                        if (Outfilectr > 0)
                        {
                            int j = 0;
                            if (Flag_eg1200 == true)
                            {
                                foreach (channel Member in Channel )

                                {
                                    if (Member._hoehe > 0)
                                    {
                                        Outfile.Write(Datensatz[j++]);
                                        Outfile.Write("\t");
                                    }
                                    else
                                    {
                                        Outfile.Write(0);
                                        Outfile.Write("\t");
                                    }
                                }
                            }
                            else
                            {
                                foreach (channel Member in Channel)
                                {
                                    Control[] temp = form1.splitContainer1.Panel1.Controls.Find(("checkbox_"+Member.CH_name), true);
                                    if (temp.Length>0)
                                    {
                                        if (Member._hoehe > 0)
                                        {
                                            Outfile.Write(Datensatz[j++]);
                                            Outfile.Write("\t");
                                        }
                                        else
                                        {
                                            Outfile.Write(0);
                                            Outfile.Write("\t");
                                        }
                                    }
                                }
                            }
                            
                            Outfile.WriteLine(Outfilectr);
                            Outfilectr++;
                        }
                    }
                 
                }
            }

            // Refresh Picturebox of graph
            public void update()
            {
                if ((display_diag_exit == true) && (Status_ok == true))
                {

                    form1.pictureBox_Graph.Invalidate();

                    
                }
            }

            bool display_diag_exit = false;
            
            Bitmap bmp1;
            
            // Funktion to draw diagrammlegend
            private void draw_Diagramm(channel ch)
            {
                PictureBox PicB = form1.pictureBox_Graph;
               
                Graphics g = Graphics.FromImage(bmp1);

                Pen blackPen = new Pen(Color.Black, 1);
                int dumint;
                int tempxrand = ((PicB.Width / column) - 10);

                if (ch._hoehe > 0) 		//				(* Achsen zeichnen	*)		
                {
                    blackPen.DashStyle = DashStyle.Solid;
                    blackPen.Color = Color.Black;

                    if (ch.xoffset == true)
                    {
                       
                        g.DrawLine(blackPen, new Point(rand + (PicB.Width / column), ch._base), new Point(((PicB.Width) - 10), ch._base));
                        g.DrawLine(blackPen, new Point(rand + (PicB.Width / column), ch._base - ch._hoehe + gr_rand), new Point(rand + (PicB.Width / column), ch._base));

                        g.DrawString(ch.CH_name, new Font(FontFamily.GenericSerif, 10, FontStyle.Bold), new SolidBrush(Color.Black), new Point(rand + (PicB.Width / column), ch._base - ch._hoehe + 4));


                        blackPen.DashStyle = DashStyle.Dot;
                        blackPen.Color = Color.Gray;
                        for (int j = 1; j < 4; j++)
                        {
                            dumint = (int)(Math.Round((ch._base - (ch._hoehe - gr_rand) * (0.25 * j)), 0));
                            g.DrawLine(blackPen, new Point(rand + (PicB.Width / column), dumint), new Point(((PicB.Width) - 10), dumint));

                        }
                        for (int j = 1; j < 10; j++)
                        {
                            dumint = rand + (PicB.Width / column) + ((int)(Math.Round((double)((tempxrand - rand) * (j / 10.0)))));
                            g.DrawLine(blackPen, new Point(dumint, ch._base - ch._hoehe + gr_rand), new Point(dumint, ch._base));                        }
                    }
                    else
                    {
                        
                        g.DrawLine(blackPen, new Point(rand, ch._base), new Point(tempxrand, ch._base));
                        g.DrawLine(blackPen, new Point(rand, ch._base - ch._hoehe + gr_rand), new Point(rand, ch._base));

                        g.DrawString(ch.CH_name, new Font(FontFamily.GenericSerif, 10, FontStyle.Bold), new SolidBrush(Color.Black), new Point(rand, ch._base - ch._hoehe + 4));


                        blackPen.DashStyle = DashStyle.Dot;
                        blackPen.Color = Color.Gray;
                        for (int j = 1; j < 4; j++)
                        {
                            dumint = (int)(Math.Round((ch._base - (ch._hoehe - gr_rand) * (0.25 * j)), 0));
                            g.DrawLine(blackPen, new Point(rand, dumint), new Point(tempxrand, dumint));

                        }
                        for (int j = 1; j < 10; j++)
                        {
                            dumint = rand + ((int)(Math.Round((double)((tempxrand - rand) * (j / 10.0)))));
                            g.DrawLine(blackPen, new Point(dumint, ch._base - ch._hoehe + gr_rand), new Point(dumint, ch._base));
                        }
                    }
                  
                }
                g.Dispose();
                //PicB.Dispose();
                blackPen.Dispose();
                
            }
            
            // Draw all Diagramms
            public void display_diag()
            {
                

                PictureBox PicB = form1.pictureBox_Graph;

                int Channels = cnt_Channel;
                
                int temp_Ch = Channels;

                display_diag_exit = false;
                
                if (temp_Ch > 7)
                {
                    temp_Ch = 7;
                }
                int Diagram_height = 0;
                if (temp_Ch > 0)
                {
                     Diagram_height = ((PicB.Height - rand) / temp_Ch);
                }
                
                
                if (Channels > 0)
                {
                    if (form1.checkBox_I.Checked)
                    {
                        Channel[(int)cha.chi]._base = Diagram_height;
                        Channel[(int)cha.chi]._hoehe = Channel[(int)cha.chi]._base;
                    }
                    else
                    {
                        Channel[(int)cha.chi]._base = 0;
                        Channel[(int)cha.chi]._hoehe = 0;
                    }

                    if (form1.checkBox_II.Checked)
                    {
                        Channel[(int)cha.chii]._base = Channel[(int)cha.chi]._base + Diagram_height;
                        Channel[(int)cha.chii]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chii]._hoehe = 0;
                        Channel[(int)cha.chii]._base = Channel[(int)cha.chi]._base;
                    }

                    if (form1.checkBox_III.Checked)
                    {
                        Channel[(int)cha.chiii]._base = Channel[(int)cha.chii]._base + Diagram_height;
                        Channel[(int)cha.chiii]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chiii]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chiii]._base = Channel[(int)cha.chii]._base;
                    }

                    if (form1.checkBox_aVR.Checked)
                    {
                        Channel[(int)cha.chvr]._base = Channel[(int)cha.chiii]._base + Diagram_height;
                        Channel[(int)cha.chvr]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chvr]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chvr]._base = Channel[(int)cha.chiii]._base;
                    }
                    if (form1.checkBox_aVL.Checked)
                    {
                        Channel[(int)cha.chvl]._base = Channel[(int)cha.chvr]._base + Diagram_height;
                        Channel[(int)cha.chvl]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chvl]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chvl]._base = Channel[(int)cha.chvr]._base;
                    }

                    if (form1.checkBox_aVF.Checked)
                    {
                        Channel[(int)cha.chvf]._base = Channel[(int)cha.chvl]._base + Diagram_height;
                        Channel[(int)cha.chvf]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chvf]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chvf]._base = Channel[(int)cha.chvl]._base;
                    }
                    if (form1.checkBox_C1.Checked)
                    {
                        Channel[(int)cha.chc1]._base = Channel[(int)cha.chvf]._base + Diagram_height;
                        Channel[(int)cha.chc1]._hoehe = Diagram_height;
                    }
                    else
                    {
                        Channel[(int)cha.chc1]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc1]._base = Channel[(int)cha.chvf]._base;
                    }
                    
                    if (form1.checkBox_C2.Checked)
                    {
                        if ((Channel[(int)cha.chc1]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chc2]._base = 0 + Diagram_height;
                            Channel[(int)cha.chc2].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc2]._base = Channel[(int)cha.chc1]._base + Diagram_height;
                            Channel[(int)cha.chc2].xoffset = false;
                            
                        }
                        Channel[(int)cha.chc2]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chc2]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc2]._base = Channel[(int)cha.chc1]._base;
                        if (Channel[(int)cha.chc1].xoffset == true)
                        {
                            Channel[(int)cha.chc2].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc2].xoffset = false;
                        }
                    }

                    if (form1.checkBox_C3.Checked)
                    {
                        if ((Channel[(int)cha.chc2]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chc3]._base = 0 + Diagram_height;

                            Channel[(int)cha.chc3].xoffset = true;
                            

                        }
                        else
                        {
                            Channel[(int)cha.chc3]._base = Channel[(int)cha.chc2]._base + Diagram_height;
                            if (Channel[(int)cha.chc2].xoffset == true)
                            {
                                Channel[(int)cha.chc3].xoffset = true;
                            }
                            else
                            {
                                Channel[(int)cha.chc3].xoffset = false;
                            }
                            

                        }
                        Channel[(int)cha.chc3]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chc3]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc3]._base = Channel[(int)cha.chc2]._base;
                        if (Channel[(int)cha.chc2].xoffset == true)
                        {
                            Channel[(int)cha.chc3].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc3].xoffset = false;
                        }
                    }
                    if (form1.checkBox_C4.Checked)
                    {
                        if ((Channel[(int)cha.chc3]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chc4]._base = 0 + Diagram_height;
                            Channel[(int)cha.chc4].xoffset = true;
                            

                        }
                        else
                        {
                            Channel[(int)cha.chc4]._base = Channel[(int)cha.chc3]._base + Diagram_height;
                            if (Channel[(int)cha.chc3].xoffset == true)
                            {
                                Channel[(int)cha.chc4].xoffset = true;
                            }
                            else
                            {
                                Channel[(int)cha.chc4].xoffset = false;
                            }

                        }
                        Channel[(int)cha.chc4]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chc4]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc4]._base = Channel[(int)cha.chc3]._base;
                        if (Channel[(int)cha.chc3].xoffset == true)
                        {
                            Channel[(int)cha.chc4].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc4].xoffset = false;
                        }
                    }
                    if (form1.checkBox_C5.Checked)
                    {
                        if ((Channel[(int)cha.chc4]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chc5]._base = 0 + Diagram_height;
                            Channel[(int)cha.chc5].xoffset = true;


                        }
                        else
                        {
                            Channel[(int)cha.chc5]._base = Channel[(int)cha.chc4]._base + Diagram_height;
                            if (Channel[(int)cha.chc4].xoffset == true)
                            {
                                Channel[(int)cha.chc5].xoffset = true;
                            }
                            else
                            {
                                Channel[(int)cha.chc5].xoffset = false;
                            }
                        }
                        Channel[(int)cha.chc5]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chc5]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc5]._base = Channel[(int)cha.chc4]._base;
                        if (Channel[(int)cha.chc4].xoffset == true)
                        {
                            Channel[(int)cha.chc5].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc5].xoffset = false;
                        }
                    }
                    if (form1.checkBox_C6.Checked)
                    {
                        if ((Channel[(int)cha.chc5]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chc6]._base = 0 + Diagram_height;
                            Channel[(int)cha.chc6].xoffset = true;


                        }
                        else
                        {
                            Channel[(int)cha.chc6]._base = Channel[(int)cha.chc5]._base + Diagram_height;
                            if (Channel[(int)cha.chc5].xoffset == true)
                            {
                                Channel[(int)cha.chc6].xoffset = true;
                            }
                            else
                            {
                                Channel[(int)cha.chc6].xoffset = false;
                            }
                        }

                        Channel[(int)cha.chc6]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chc6]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chc6]._base = Channel[(int)cha.chc5]._base;
                        if (Channel[(int)cha.chc5].xoffset == true)
                        {
                            Channel[(int)cha.chc6].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chc6].xoffset = false;
                        }
                    }
                    if (form1.checkBox_Resp.Checked)
                    {
                        if ((Channel[(int)cha.chc6]._base + Diagram_height) > PicB.Height)
                        {
                            Channel[(int)cha.chresp]._base = 0 + Diagram_height;
                            Channel[(int)cha.chresp].xoffset = true;
                            

                        }
                        else
                        {
                            Channel[(int)cha.chresp]._base = Channel[(int)cha.chc6]._base + Diagram_height;
                            if (Channel[(int)cha.chc6].xoffset == true)
                            {
                                Channel[(int)cha.chresp].xoffset = true;
                            }
                            else
                            {
                                Channel[(int)cha.chresp].xoffset = false;
                            }
                        }
                        Channel[(int)cha.chresp]._hoehe = Diagram_height;

                    }
                    else
                    {
                        Channel[(int)cha.chresp]._hoehe = 0;			//(* nicht darstellen	*)
                        Channel[(int)cha.chresp]._base = Channel[(int)cha.chc6]._base;
                        if (Channel[(int)cha.chc6].xoffset == true)
                        {
                            Channel[(int)cha.chresp].xoffset = true;
                        }
                        else
                        {
                            Channel[(int)cha.chresp].xoffset = false;
                        }

                    }

                    

                    if (PicB.Height > 0)
                    {
                        bmp1 = new Bitmap(PicB.Width, PicB.Height);

                        Graphics g = Graphics.FromImage(bmp1);

                        Pen blackPen = new Pen(Color.Black, 1);
                        g.Clear(Color.White);
                        string tempstr = Max_Wert.ToString() + " mv";
                        //g.DrawLine(blackPen, new Point(rand-10,  gr_rand), new Point(rand-10,Diagram_height));
                        g.DrawString("0 mv", new Font(FontFamily.GenericSerif, 8, FontStyle.Regular), new SolidBrush(Color.Black), new Point(3, Diagram_height-5));
                        g.DrawString(tempstr, new Font(FontFamily.GenericSerif, 8, FontStyle.Regular), new SolidBrush(Color.Black), new Point(3, gr_rand-5));

                        foreach (channel Member in Channel)
                        {
                            draw_Diagramm(Member);
                        }
                        

                        form1.pictureBox_Graph.Image = bmp1;
                        form1.pictureBox_Graph.Refresh();
                        display_diag_exit = true;
                        g.Dispose();
                        //PicB.Dispose();
                        blackPen.Dispose();
                    }
                }
            }
        }

        private void label_Identify_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.WriteLine("I");
            }
        }

        private void button_Calibrate_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.WriteLine("K");
            }
        }

        

        
       

             
    }
}